--英雄召唤 主界面
checkRequire("Lua_RecruitMainPanel");
checkRequire("Lua_RecruitScoutPanel");
checkRequire("Lua_NewHeroActRecruitPanel");
checkRequire("Lua_RecruitTweenState");
Lua_RecruitMainWindow = class("Lua_RecruitMainWindow", Lua_Window);
function Lua_RecruitMainWindow:ctor()
	self:superCall("ctor");

	self.isFullSizeWin = true;
	self.isFullPaving = true;
	self.showBlackMask = true;
    self.showBackBtn = true;--显示返回按键
    self.skinName = "RecruitMainWindow_skin";
    self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;

    self.windowName = "Lua_RecruitMainWindow";
    self:preLoadSelfRes();
end

-- 预加载资源
function Lua_RecruitMainWindow:preLoadSelfRes()
	-- Lua_RecruitMainPanel 招募：友情招募、高级招募 预加载
	self:addPreLoadRes("/images/recruit/ui_xmb_bg_01.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/recruit/ui_xmb_bg_04.png", Lua_LoadFileType.IMG);
end

function Lua_RecruitMainWindow:buildShowItem()
	self:superCall("buildShowItem");


	self.winBottomObj = UICreate.createGameObject(self.content, 0, 60.5, 0);
	self.winBottomObj.name = "winBottomObj";
	self.winBottomObj:AddComponent(typeof(UnityEngine.RectTransform));
	LuaUtil.setRectSize(self.winBottomObj, 720, 121);
	LuaUtil.setObjAnchor(self.winBottomObj, Lua_WindowUtil.getAnchor(7));
	self.backBtn:setParent(self.winBottomObj);

    self.roleInfoPanel = Lua_RoleInfoPanel.new(self.content)
    self.roleInfoPanel.content.name = "roleInfoPanel";
    self.roleInfoPanel:setRectAnchor(1)

	self.panelList = {};
	self.selectIndex = 0;

	self.downBg = UICreate.createUIAtlasImage(self.winBottomObj, "common_altas_1", "ui_common_widget_005", 0, 0, 720, 121);
	self.downBg.pivot = Lua_WindowUtil.getPivot(7);
	self.downBg.anchor = Lua_WindowUtil.getAnchor(7);
	self.downBg:setLocation(0, -5, 0);

	self.panelArr = Array();
	self.panelArr:add({textAtlas = "recruit_atlas_2", textUnOpenSprite = "xui_xmb_zgnbutton_1_d", textNormalSprite = "xui_xmb_zgnbutton_1_n", textSelectedSprite = "xui_xmb_zgnbutton_1_p", panel = Lua_RecruitMainPanel, textStr = LanUtil.getValue(140300), redPointId = Lua_RedPointList.RecruitTab});
	self.panelArr:add({textAtlas = "recruit_atlas_2", textUnOpenSprite = "xui_mhj_zgnbutton_1_d", textNormalSprite = "xui_mhj_zgnbutton_1_n", textSelectedSprite = "xui_mhj_zgnbutton_1_p", panel = Lua_RecruitScoutPanel,   textStr = LanUtil.getValue(140301), openId = 10078});

	local actArr = DataCenter.backstageActData:getActIdxArrByType(Lua_NewHeroActivityData.RECRUIT);
	if actArr ~= nil then
		local actVo;
		for i = 1, actArr:getSize() do
			actVo = DataCenter.backstageActData:getActVoByIdx(actArr[i]);
			self.panelArr:add({ panel = Lua_NewHeroActRecruitPanel, textStr = "魔神召唤", redPointId = "2000400", data = actVo });
		end
	end

	self.panelBtnList = Lua_ButtonList.new(self.winBottomObj, Lua_AxisDefine.Horizontal);
	self.panelBtnList.pivot = -1;
	self.panelBtnList:setRectAnchor(7);
	self.panelBtnList:setLocation(241, 54, 0);
	self.panelBtnList:setButtonStyle("common_altas_1", "ui_common_button_001_b", "ui_common_button_001_b", 118, 108, 0.01, 1);
	self.panelBtnList:setButtonLine("common_altas_1", "ui_common_line_011", 2, 108, 0, 0, 1);
	self.panelBtnList:setButtonItem(120, 108);
    self.panelBtnList:setRedPoint(40, 40);
	self.panelBtnList:setClickCallBack(self, self.changePanel);
	self.panelBtnList:setData(self.panelArr);
	-- self.panelBtnList:setSelected(1);

	self.backBtn.siblingIndex = -1;
	self:addRecruitTween();
	self:showEffect(true, "xiaomaibu", -71, -1160);
	self:addLuaEvent("RECRUIT_OPEN_MASK", self, self.showRecruitMask); --盲盒机招募时遮罩
end

function Lua_RecruitMainWindow:showWin(param)
	self:superCall("showWin", param);

	local index = 1;
	if type(param) == "number" then
		index = param;
	elseif type(param) == "table" and param.main_id ~= nil then
		index = param.main_id;
	end
	
	self.panelBtnList:setSelected(index);
end

function Lua_RecruitMainWindow:changePanel(val)
	if self.selectIndex == val then
		return; 
	end

	if self.selectIndex ~= nil then
		self.panel = self.panelList[self.selectIndex];
		if self.panel ~= nil then
			self.panel:setEnable(false);
		end
	end
	self.selectIndex = val;

	local data = self.panelArr[val];

	self.panel = self.panelList[val];
	if self.panel == nil then
		self.panel = data.panel.new(self.content);
		self.panel:setRectAnchor(9);
		self.panelList[val] = self.panel;
	else
		self.panel:setEnable(true);
	end
	
	self.panel:setSiblingIndex(3);
	if self.panel.setData ~= nil then
		self.panel:setData(data.data);
	end

	self.roleInfoPanel:setEnable(val ~= 2)
	self:showMask(val == 2)
	if self.tweenName ~= nil then
		DataCenter.winTweenManager:removeWinTween(self.tweenName);
	end
	self.tweenName = DataCenter.winTweenManager:createWinTween(self.panel.classname, self.content.transform)
end

function Lua_RecruitMainWindow:showMask(value)
	if value then
		if self.panelMask == nil then
			self.panelMask = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 0, 2048, 2048)
			self.panelMask.alpha = 0.9
		end
		self.panelMask.siblingIndex = self.panel.siblingIndex
		self.panelMask:setEnable(true)
	else
		if self.panelMask then
			self.panelMask:setEnable(false)
		end
	end
end

-- 添加招募动画
function Lua_RecruitMainWindow:addRecruitTween()
	if self.winBottomObj then
		Lua_RecruitTweenState.addTweenObj(self.winBottomObj);
	end
	if self.roleInfoPanel then
		Lua_RecruitTweenState.addTweenObj(self.roleInfoPanel.content);
	end
end

-- 移除招募动画
function Lua_RecruitMainWindow:removeRecruitTween()
	if self.winBottomObj then
		Lua_RecruitTweenState.removeTween(self.winBottomObj, "recruit_movingUI");
	end
	if self.roleInfoPanel then
		Lua_RecruitTweenState.removeTween(self.roleInfoPanel.content, "recruit_movingUI");
	end
end

function Lua_RecruitMainWindow:showRecruitMask(bShow)
    if bShow then
        if self.recruitMaskBg == nil then
            self.recruitMaskBg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "black_mask", 0, 0, 2048, 2048);
            self.recruitMaskBg.name = "recruitMaskBg";
            self.recruitMaskBg.alpha = 0.1;
            self.recruitMaskBg:addClickFuntion(self, self.onClickRecruitMaskBg);
        end
        self.recruitMaskBg:setEnable(true);
        Lua_CommonUtil.removeTimer(self, self.showRecruitMask);
        Lua_CommonUtil.delayCall(2.2, self, self.showRecruitMask, false);
    else
        if self.recruitMaskBg ~= nil then
            self.recruitMaskBg:setEnable(false);
        end
    end
end

function Lua_RecruitMainWindow:onClickRecruitMaskBg()
	OperateAlert.showLangValue(140370);
end

function Lua_RecruitMainWindow:showEffect(bShow, effectName, posX, posY)
	if bShow then
		local _effectName = effectName or "xiaomaibu";
		local _url = "/effects/uiEffects/".._effectName;
		local _posX = posX or 0;
		local _posY = posY or 0;
		if self.uiEffect == nil then
	  		self.uiEffect = UICreate.createUIEffect(self.content, _url, _effectName, _posX, _posY);
	  		self.uiEffect.anchorValue = 1;
	  		self.uiEffect.siblingIndex = 1;
	  	else
	  		self.uiEffect:setUrl(_url, _effectName);
	  		self.uiEffect:setLocation(_posX, _posY);
	   	end
	   	self.uiEffect:setEnable(true);
	else
		if self.uiEffect ~= nil then
			self.uiEffect:setEnable(false);
		end
	end
end

function Lua_RecruitMainWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.showRecruitMask);
	self:removeRecruitTween();
	if self.roleInfoPanel then
		self.roleInfoPanel:dispose()
		self.roleInfoPanel = nil
	end
	if self.panelArr ~= nil then
		self.panelArr:clear();
		self.panelArr = nil;
	end
	if self.panelList ~= nil then
		for k, panel in pairs (self.panelList) do
			panel:dispose();
			self.panelList[k] = nil;
		end
		self.panelList = nil;
	end
	if self.panelBtnList ~= nil then
		self.panelBtnList:dispose();
		self.panelBtnList = nil;
	end
	if self.downBg ~= nil then
		self.downBg:dispose();
		self.downBg = nil;
	end
	if self.winBottomObj ~= nil and IsNil(self.winBottomObj) == false then
		UnityEngine.GameObject.Destroy(self.winBottomObj);
		self.winBottomObj = nil;
	end

    if self.recruitMaskBg ~= nil then
        self.recruitMaskBg:dispose();
        self.recruitMaskBg = nil;
    end
    if self.uiEffect ~= nil then
    	self.uiEffect:dispose();
    	self.uiEffect = nil;
    end
	DataCenter.winTweenManager:removeWinTween(self.tweenName);
	self.tweenName = nil;
	self:superCall("dispose");
end