-- 招募显示英雄界面
checkRequire("Lua_HeroSkillItem"); --英雄技能 Item
Lua_RecruitShowSingleHeroWindow = class("Lua_RecruitShowSingleHeroWindow", Lua_Window);
function Lua_RecruitShowSingleHeroWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_RecruitShowSingleHeroWindow";
    self.skinName = "RecruitShowSingleHeroWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
	self.isFullSizeBg = true;
	self.showBlackMask = true;
	self.blackAlpha = 0.1;
end

function Lua_RecruitShowSingleHeroWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.type_icon:addClickFuntion(self, self.onCompBtnClick);--阵容克制描述
end

function Lua_RecruitShowSingleHeroWindow:showWin(param)
	self:superCall("showWin", param);

	if param.modelScenePanel then
		self.modelScenePanel = param.modelScenePanel
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
		param.modelScenePanel = nil
	end

	if param.heroArr == nil then
		self:showModel(param);
		self:showHeroInfo(param);
	else
		self:showModel(param.heroVo);
		self:showHeroInfo(param.heroVo);
	end

	Lua_CommonUtil.delayCall(0.5, self, self.onDelay)
end

function Lua_RecruitShowSingleHeroWindow:onDelay()
    self.isClickClose = true;
    self:createCloseTips(0, 146, 0);
    self.closeText.anchorValue = 7;
end

function Lua_RecruitShowSingleHeroWindow:onMaskClick(go)
	if self.showData == nil or self.showData.heroArr == nil then
		self:superCall("onMaskClick", go);
		return;
	end

	local heroId = self.showData.heroArr:shift();
	if heroId == nil then
		self:superCall("onMaskClick", go);
		return;
	end

	self.data = Lua_HeroVo.new(heroId);
	self:showModel(self.data);
end

function Lua_RecruitShowSingleHeroWindow:showHeroInfo(vo)
	self.title.text = vo.title;
	self.name.text = vo.name;
	self.type_icon:setAltas("common_altas_3", "xui_common_attribute_"..29 + vo.campType);
	self.carrerTxt.text = vo.career_des;
	self.main_icon:setEnable(vo.bcore);
	self:showStar(vo.star);
	self:showSkills(vo);
end

function Lua_RecruitShowSingleHeroWindow:showStar(starNum)
	if self.starArr == nil then
		self.starArr = Array();
	end
	local len = self.starArr:getSize();
	local maxLen = starNum > len and starNum or len;
	local item;
	for i = 1, maxLen do
		item = self.starArr[i];
		if i > starNum then
			if item then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_label_06", 0, 0, 0, 0);
				item.anchorValue = 1;
				self.starArr:add(item);
			else
				item:setEnable(true);
			end
		end
	end

	len = starNum;
	local space = 46;
	local w = -(space * len) / 2 + space / 2;
	for i = 1, len do
		item = self.starArr[i];
		item:setLocation(((i - 1) % len) * space + w, -98, 0);
	end
end

function Lua_RecruitShowSingleHeroWindow:showSkills(hvo)
    local info = hvo.heroSkillInfo;
    local bConnect = hvo.connectId > 0;
	if info ~= nil then
        if self.skillArr == nil then
            self.skillArr = Array();
        end
        local len = self.skillArr:getSize();
        for i = 1, len do
            self.skillArr[i]:setEnable(false);
        end
        local skilWidth = bConnect and 130 or 170;
        local offectX = bConnect and 73 or 0;
        for i=1,#info do
            local item = nil;
            if self.skillArr[i] ~= nil then
                item = self.skillArr[i];
            else
                item = Lua_HeroSkillItem.new(self.content);
                item:setRectAnchor(7);
                self.skillArr:add(item);
            end
            item:setData(info[i]);
            item:setShowLevel(false);
            local x = -1 * skilWidth * #info / 2 + skilWidth * (i-1) + skilWidth / 2;
            item:setLocation(x-offectX, 331, 0);
            item:setEnable(true);
        end
    else
        if self.skillArr ~= nil then
            local len = self.skillArr:getSize();
            for i = 1, len do
                self.skillArr[i]:setEnable(false);
            end
        end
    end

	if bConnect then
        if self.planSkillItem == nil then
            self.planSkillItem = Lua_HeroSkillItem.new(self.content);--连携技能
            self.planSkillItem:setRectAnchor(7);
            self.planSkillItem:setLocation(272,331,0);
        end
        self.planSkillItem:setEnable(true);
        self.planSkillItem:setConnectData(hvo);
    else
        if self.planSkillItem ~= nil then
            self.planSkillItem:setEnable(false);
        end
    end
    self:showLine(bConnect);
end

--连携封线
function Lua_RecruitShowSingleHeroWindow:showLine(bool)
	if bool then
		if self.lineSpr == nil then
			self.lineSpr = UICreate.createUIAtlasImage(self.content, "common_altas_3", "xui_common_line_008", 220, 328, 1, 118);
			self.lineSpr:setAnchorMin(0.5, 0);
    		self.lineSpr:setAnchorMax(0.5, 0);
		end
		self.lineSpr:setEnable(true);
	else
		if self.lineSpr ~= nil then
			self.lineSpr:setEnable(false);
		end
	end
end

function Lua_RecruitShowSingleHeroWindow:showModel(vo)
	if self.modelScenePanel == nil then
		self.modelScenePanel = Lua_ModelScenePanel.new()
		self.modelScenePanel:setParent(self.content)
		self.modelScenePanel:setRotBgDimensions(720, 720)
		self.modelScenePanel:setRotBgPos(0, 130)
	end

	if self.bInitModel or not self.modelScenePanel.bShowModel then
		self.modelScenePanel:setModelDir(vo.uiModelDir)
		self.modelScenePanel:setModelScale(vo.uiModelScale)
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UIWAIT, vo.poseActEffs)
		self.modelScenePanel:addActIdEffs(Lua_ThingDefine.UISHOW, vo.showActEffs)
		self.modelScenePanel:showModelScene(vo.uiSceneId, vo.uiModelUrl, vo.uiModelAvatarName, vo.uiModelCamController)
		self.modelScenePanel:setModelAct(vo.uiShowAct, Lua_ThingDefine.UIWAIT, true)
		self.modelScenePanel:addModelCallBack(self, self.onModelLoaded, nil)
	end
	 self.bInitModel = true
end

function Lua_RecruitShowSingleHeroWindow:onModelLoaded()
	if self.data == nil then
		return;
	end
	self:showHeroInfo(self.data);
end

-- 克制描述
function Lua_RecruitShowSingleHeroWindow:onCompBtnClick()
	local hvo = self.showData
	if self.showData.heroArr ~= nil then
		hvo = self.showData.heroVo;
	end
    Lua_WindowUtil.openWin("Lua_HeroCampDesTipsWindow", Lua_WinParam.ACTION_OPEN, {camp = hvo.campType, pos = {0, 520 + self.adaptHeight/2}});
end


function Lua_RecruitShowSingleHeroWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.onDelay);
	DataCenter.guideData:removeShowModel(self.windowName); -- 引导用
	if self.modelScenePanel ~= nil then
		self.modelScenePanel:dispose()
		self.modelScenePanel = nil
	end
	if self.starArr then
		self.starArr:dispose();
		self.starArr = nil;
	end
	if self.skillArr then
		self.skillArr:dispose();
		self.skillArr = nil;
	end
	if self.showData and self.showData.heroArr then
		self.showData.heroArr:clear()
		self.showData.heroArr = nil;
	end

	if self.planSkillItem ~= nil then
        self.planSkillItem:dispose();
        self.planSkillItem = nil;
    end
    self.lineSpr = nil;
	self.data = nil;
	Lua_MsgUtil.callFunc("SINGLE_HERO_WIN_HIDE");
	self:superCall("dispose");
end

