--新英雄主题活动 招募Panel
checkRequire("Lua_RecruitCostItem");
Lua_NewHeroActRecruitPanel = class("Lua_NewHeroActRecruitPanel", Lua_DisplayObject);

function Lua_NewHeroActRecruitPanel:ctor(p)
	self:superCall("ctor", p, "NewHeroActRecruitPanel_skin");
end

function Lua_NewHeroActRecruitPanel:buildPanel()
	self:superCall("buildPanel");

	self:addLuaEvent("UPDATE_NEWHERO_RECRUIT", self, self.updateData);
end

function Lua_NewHeroActRecruitPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.rectTf:SetSiblingIndex(3);

	self.showItem = Lua_RecruitCostItem.new(self.downObj);
	self.showItem:setLocation(140, -290, 0);

	self.tipIcon:addClickFuntion(self, self.onTipIconClick);
	self.previewIcon:addClickFuntion(self, self.onPreviewClick);
	self.oneBtn:addClickFuntion(self, self.onOneBtnClick);
	self.tenBtn:addClickFuntion(self, self.onTenBtnClick);
end

function Lua_NewHeroActRecruitPanel:dispose()
	self.actVo = nil;

	if self.showItem ~= nil then
		self.showItem:dispose();
		self.showItem = nil;
	end
	if self.redPointList ~= nil then
		for k, v in pairs(self.redPointList) do
			v:dispose();
			v = nil;
		end
		self.redPointList = nil;
	end
	self:superCall("dispose");
end

function Lua_NewHeroActRecruitPanel:setData(data)
	self.actVo = data;
end

function Lua_NewHeroActRecruitPanel:updateData()
	local newHeroActData = DataCenter.newHeroActData;

	self.heroVo = Lua_HeroVo.new(newHeroActData.heroId);
	self.campIcon:setAltas("common_altas_2", "ui_common_button_0".. 25 + self.heroVo.campType .. "_n");
	self.nameTxt.text = self.heroVo.name;
	self.titleTxt.text = self.heroVo.title;
	self.heroImg:setUrl("/images/hero_atlas/ui_hbtj_lh_001.png");

	local startDate = Lua_TimeTransform.transSeconds25(self.actVo.start_tick, false);
	local endDate = Lua_TimeTransform.transSeconds25(self.actVo.end_tick, false);
	self.timeTxt.text = LanUtil.formateStr("{1}-{2}{3}召唤概率", startDate, endDate, self.heroVo.name);
	self.remainTxt.text = LanUtil.formateStr("再召唤{1}次必得Up", newHeroActData.mustTime);
	self.diamondLimitTxt.text = LanUtil.formateStr("钻石招募剩余次数：{1}/{2}", newHeroActData.diamondTime, newHeroActData.diamondLimit);

	local moneyVo = Lua_ResourcesData.getConfigDataById(Lua_ResourcesDefine.DIAMOND)
	local itemVo = Lua_ToolVo.new(newHeroActData.costItemId);
	self.itemNum = DataCenter.packData:getItemCountById(newHeroActData.costItemId);
	if self.itemNum >= newHeroActData.oneDrawTime then
		self.oneCostIcon:setAltas(itemVo.atlas, itemVo.sprite);
		self.oneCostTxt.text = newHeroActData.oneDrawTime;
	else
		self.oneCostIcon:setAltas(moneyVo.iconAtlas, moneyVo.iconSprite);
		self.oneCostTxt.text = newHeroActData.oneDrawCost;
	end

	if self.itemNum >= newHeroActData.tenDrawTime then
		self.tenCostIcon:setAltas(itemVo.atlas, itemVo.sprite);
		self.tenCostTxt.text = newHeroActData.tenDrawTime;
	else
		self.tenCostIcon:setAltas(moneyVo.iconAtlas, moneyVo.iconSprite);
		self.tenCostTxt.text = newHeroActData.tenDrawCost;
	end

	self.isFree = newHeroActData.isFreeDraw == 1;
	self.freeTxt:setEnable(self.isFree);
	self.oneCostIcon:setEnable(not self.isFree);
	self.oneCostTxt:setEnable(not self.isFree);
	self:checkRedPoint(1, self.isFree);
	self:checkRedPoint(2, self.itemNum >= newHeroActData.tenDrawTime);

	self.showItem:setData(newHeroActData.costItemId);
end

function Lua_NewHeroActRecruitPanel:checkRedPoint(type, val)
	if self.redPointList == nil then
		self.redPointList = {};
	end

	if val and self.redPointList[type] == nil then
		self.redPointList[type] = Lua_RedPointIcon.new(self.content);
		self.redPointList[type]:createRedPointEff();
		self.redPointList[type]:setLocation(-70 + (type - 1) * 290, -330, 0)
	end

	if self.redPointList[type] ~= nil then
		self.redPointList[type]:updateRedPointShow(val);
	end
end

function Lua_NewHeroActRecruitPanel:onTipIconClick(go)
	local tipsData = { des = "这是提示", posX = 155, posY = -200 };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_NewHeroActRecruitPanel:onPreviewClick(go)
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(DataCenter.newHeroActData.fightPreviewId);
end

function Lua_NewHeroActRecruitPanel:onOneBtnClick(go)
	local newHeroActData = DataCenter.newHeroActData;
	if not DataCenter.heroData:isBagEnough(newHeroActData.oneDrawTime) then
		OperateAlert.showLangValue(140321);
		return;
	end
	newHeroActData.selectNum = newHeroActData.oneDrawTime;
	newHeroActData.diamondCost = newHeroActData.oneDrawCost;

	if self.isFree or self.itemNum >= newHeroActData.oneDrawTime then
		self:onSureFun();
	else
		if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, newHeroActData.oneDrawCost, true) then
			if newHeroActData.diamondTime >= newHeroActData.oneDrawTime then
				self:onShowTip();
			else
				OperateAlert.show("今天剩余钻石招募次数不足");
			end
		end
	end
end

function Lua_NewHeroActRecruitPanel:onTenBtnClick(go)
	local newHeroActData = DataCenter.newHeroActData;
	if not DataCenter.heroData:isBagEnough(newHeroActData.tenDrawTime) then
		OperateAlert.showLangValue(140321);
		return;
	end
	newHeroActData.selectNum = newHeroActData.tenDrawTime;
	newHeroActData.diamondCost = newHeroActData.tenDrawCost;

	if self.itemNum >= newHeroActData.tenDrawTime then
		self:onSureFun();
	else
		if DataCenter.moneyData:isMoneyEnough(Lua_ResourcesDefine.DIAMOND, newHeroActData.tenDrawCost, true) then
			if newHeroActData.diamondTime >= newHeroActData.tenDrawTime then
				self:onShowTip();
			else
				OperateAlert.show("今天剩余钻石招募次数不足");
			end
		end
	end
end

function Lua_NewHeroActRecruitPanel:onShowTip()
	local newHeroActData = DataCenter.newHeroActData;
	local moneyNum = DataCenter.moneyData:getMoney(Lua_ResourcesDefine.DIAMOND);
	local getExp = newHeroActData.selectNum * newHeroActData.oneDrawExp;
	local str = spliceIconStrById(Lua_ResourcesDefine.GOLD);
	local tipsData = {
		des = LanUtil.formateStr("是否使用{1}{2}(拥有：{3})\n购买{4}英雄经验(同时附赠{5}次招募)", str, newHeroActData.diamondCost, moneyNum, getExp, newHeroActData.selectNum),
		posY = 60, btnType = 1, owner = self, sureFun = self.onSureFun
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_NewHeroActRecruitPanel:onSureFun()
	Lua_ProxyManager.getProxy("Lua_NewHeroActivityProxy"):sRecruitReward(self.actVo.actIdx, DataCenter.newHeroActData.selectNum);
end